precision mediump float;

uniform sampler2D u_Texture;
varying vec2 v_TexCoord;
uniform float iTime;
uniform float iZoom;
uniform vec2 iResolution;
uniform vec4 iRect1; // top, bottom, left, right. This rect represents a country rect boundary


#define SCALE 1.0 / ( iResolution.x ) / (iZoom * .05)
#define SPEED 2.0
#define FREQUENCY 3.

float d;
// Circle
#define C(p, o)  min(1., sqrt(10.*abs(length((p-.5)/(o + .001))-.4)))
// Little dot
#define D(p,o)  ( (d=length(p-o)*5.)<=.6 ? d:1. )

void main()
{
    gl_FragColor = texture2D(u_Texture, v_TexCoord);

    // Country fill
    if (gl_FragColor.rgb == vec3(0.0)) {
        gl_FragColor = vec4(0.435, 0.737, 0.266, 0.5);
    }
    // All the country borders
    else if (gl_FragColor.r >= 0.5 &&
        gl_FragColor.g >= 0.5 &&
        gl_FragColor.b >= 0.5 &&
        gl_FragColor.a == 1.0) {

        gl_FragColor.xyz = vec3(0.435, 0.737, 0.266);
    }
    // Selected country border
    else  if (gl_FragColor.r >= 0.6 &&
        gl_FragColor.g >= 0.6 &&
        gl_FragColor.b <= 0.3 &&
        gl_FragColor.a == 1.0) {

        gl_FragColor = vec4(0.435, 0.737, 0.266, 1.0);
    }
}