precision mediump float;

uniform sampler2D u_Texture;
uniform sampler2D u_VanishTexture;
varying vec2 v_TexCoord;
uniform float iTime;
uniform float iZoom;
uniform vec4 effectColor;
uniform float iTimeTrigger;
uniform vec2 iResolution;


void main()
{
    vec2 uv = v_TexCoord.xy;

    // Threshold
    float th = 1.0 - ( iTimeTrigger / 2000.0);

    // An auxiliary texture is being used along with a mask to transitively replace the main texture
    float auxTexture = ((texture2D(u_VanishTexture, uv ).r -.5) + 2. * uv.y ) / 3.;
    float mask = smoothstep( th - .7, th, auxTexture);
    float dist = smoothstep( th - .9, th + .1, auxTexture);
    float col = pow( smoothstep( th - .2, th + .15, auxTexture), 3.);

    vec4 color = texture2D(u_Texture, uv * (.7 + pow(dist, 2.) * .3 ));
    vec4 discolor = color * effectColor;

    gl_FragColor = mix(discolor, color, col) * mask;
}
